<section *ngIf="workspaces" class="section">

  <app-delete-workspace-modal *ngIf="isDeleteWorkspaceModalActive()"></app-delete-workspace-modal>

  <div class="container">

    <div class="field has-addons">
      <div class="control is-expanded">
        <input class="input is-medium" [(ngModel)]="searchFilter" type="text" placeholder="Search ...">
      </div>
      <div class="control">
        <a class="button is-light is-medium" (click)="clearSearch()">
          <span>
            Clear
          </span>
        </a>
      </div>
    </div>

    <hr>

    <div class="field is-grouped">
      <div class="control">
        <a class="button has-background-primary is-primary is-medium" (click)="addWorkspace()">
            <span class="icon">
              <i class="fas fa-plus"></i>
            </span>
        </a>
      </div>
      <div class="control is-expanded">
        <input class="input is-medium" [(ngModel)]="workspaceToAddName" (keyup.enter)="addWorkspace()" type="text"
               placeholder="Add new workspace">
      </div>

      <div class="field">
        <div class="control has-icons-left">
          <div class="select is-primary is-medium">
            <select [(ngModel)]="workspaceToAddVCSClient" >
              <option value="{{vcsClients.GITHUB}}" >{{ vcsClients.GITHUB }}</option>
              <option value="{{vcsClients.GITLAB}}" >{{ vcsClients.GITLAB }}</option>
            </select>
          </div>
            <div class="icon is-small is-left " [ngSwitch]="workspaceToAddVCSClient">
              <i *ngSwitchCase="vcsClients.GITHUB" class="fab fa-github has-text-primary"></i>
              <i *ngSwitchCase="vcsClients.GITLAB" class="fab fa-gitlab has-text-secondary"></i>
            </div>
        </div>
      </div>

    </div>

        <div *ngFor="let workspace of workspaces | workspaceFilter: searchFilter" class="box ">
          <div class="level ">
            <div class="level-left has-text-white">
              <div *ngIf="isRenameActive(workspace); else nameBlock" class="level-item">
                <div class="field has-addons">
                  <div class="control">
                    <a class="button is-danger" (click)="disactiveRenameWorkspace()">
                  <span class="icon">
                    <i class="fas fa-times"></i>
                  </span>
                    </a>
                  </div>
                  <div class="control">
                    <input class="input is-rounded" [(ngModel)]="newWorkspaceName"
                           (keyup.enter)="renameWorkspace(workspace)" type="text" placeholder="Rename workspace">
                  </div>
                  <div class="control">
                    <a class="button is-primary" (click)="renameWorkspace(workspace)">
                      <p>Rename</p>
                    </a>
                  </div>
                </div>
              </div>
              <ng-template #nameBlock>
                <div class="level-item">

                  <div [ngSwitch]="workspace.vcs" class="mr-2 is-size-4">
                    <i *ngSwitchCase="vcsClients.GITHUB" class="fab fa-github has-text-primary"></i>
                    <i *ngSwitchCase="vcsClients.GITLAB" class="fab fa-gitlab has-text-secondary"></i>
                  </div>

                  <h3 class="title is-3">
                    <a class="has-text-primary" (click)="openWorkspace(workspace)">{{ workspace.name }}</a>
                  </h3>
                </div>
              </ng-template>
            </div>

            <div class="level-right">
              <div class="level-item">
                <div class="dropdown is-hoverable">
                  <div class="dropdown-trigger">
                    <button class="button is-primary" aria-haspopup="true"
                            aria-controls="dropdown-menu">
                      <span>Edit</span>
                      <span class="icon is-small">
                    <i class="fas fa-angle-down" aria-hidden="true"></i>
                  </span>
                    </button>
                  </div>
                  <div class="dropdown-menu" id="dropdown-menu" role="menu">
                    <div class="dropdown-content">
                      <a class="dropdown-item" (click)="openWorkspace(workspace)">
                        Open
                      </a>
                      <a class="dropdown-item" (click)="activeRenameWorkspace(workspace)">
                        Rename
                      </a>
                      <a class="dropdown-item" (click)="openWorkspaceSettings(workspace)">
                        Settings
                      </a>
                      <hr class="dropdown-divider">
                      <a class="dropdown-item has-text-danger" (click)="showDeleteWorkspaceModal(workspace)">
                        Delete
                      </a>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
</section>

<router-outlet></router-outlet>
